'TierManns F@H Script
'This script simply parses the unitinfo.txt and client.cfg 
'files in the given FAHInstallPath and returns values instead of
'giving you the entire line. I just needed a quick way to pull the progress
'to a samurize progress bar instead of reading the whole asci bar from the file.

'Remember that there is no trailing slash for FAHInstallPath. It gets added here allready.
'You shouldn't need to set "Run every X min" less than 3. F@H only saves at a minimal of 3 mins anyway.
'Also, if it returns "--", then that means the file wasn't found. Recheck your path.
'I used "--" instead of an error message for when my networked box is offline.

'I provide no support for this, as it was just a quick script I threw together.
'I posted it so others can benefit from it. So if it works for you, enjoy :)


Option Explicit


'unitinfo functions
Function getUnitName(FAHInstallPath)
  getUnitName = getUnitInfo(FAHInstallPath,"unitinfo.txt","Name: ", vbCrLf)
End Function

Function getUnitTag(FAHInstallPath)
  getUnitTag = getUnitInfo(FAHInstallPath,"unitinfo.txt","Tag: ", vbCrLf)
End Function

Function getUnitProgress(FAHInstallPath)
  getUnitProgress = getUnitInfo(FAHInstallPath,"unitinfo.txt","Progress: ","%")
End Function

Function getUnitDownloadTime(FAHInstallPath)
  getUnitDownloadTime = getUnitInfo(FAHInstallPath,"unitinfo.txt","Download time: ","%")
End Function

Function getUnitDeadline(FAHInstallPath)
  getUnitDeadline = getUnitInfo(FAHInstallPath,"unitinfo.txt","Due time: ","%")
End Function


'clientinfo functions
Function getTeamNumber(FAHInstallPath)
  getTeamNumber = getUnitInfo(FAHInstallPath,"client.cfg","team=", vbLf)
End Function

Function getUserName(FAHInstallPath)
  getUserName = getUnitInfo(FAHInstallPath,"client.cfg","username=", vbLf)
End Function

Function getTotalUnitCount(FAHInstallPath)
  getTotalUnitCount = getUnitInfo(FAHInstallPath,"client.cfg","local=", vbLf)
End Function

Function getMachineID(FAHInstallPath)
  getMachineID = getUnitInfo(FAHInstallPath,"client.cfg","machineid=", vbLf)
End Function


'This is what parses the file
Private Function getUnitInfo(FAHInstallPath,UnitFile,StartCheck,EndCheck)

        Dim fileName
	fileName = FAHInstallPath & "\" & UnitFile
	
	Dim FSO
	Set FSO = CreateObject("Scripting.FileSystemObject")
	
	If FSO.FileExists(fileName) then
		Dim TextStream
		Set TextStream = FSO.OpenTextFile(fileName, 1)
		
		Dim UnitInfo
		UnitInfo = TextStream.ReadAll
		TextStream.close

                dim startpos
                dim endpos
                startpos = InStr(UnitInfo, StartCheck) + Len(StartCheck)
                endPos = InStr(startpos, UnitInfo, EndCheck) - startpos
                if InStr(UnitInfo, StartCheck) then
                 getUnitInfo = Mid(UnitInfo, startpos, endPos)
                Else
                 getUnitInfo = "--"
                End If
                
        Else
         getUnitInfo = "--"
        End If

End Function
